/*
  MYSQL (RDS/AURORA)
  NOTE #1: The unzipped content of the mysql npm (https://www.npmjs.com/package/mysql) has a default folder name of "mysql-master" and is placed in the
  same folder as your Lambda function's "index.js" file with the exception that "mysql-master" goes inside of a sub-folder called "node_modules".
  When uploading to AWS Lambda the "index.js" file and the folder "mysql-master" are zipped up together (not the folder containing your "index.js" and the
  sub-folder "node-modules" that contains "mysql-master").
  NOTE #2: There are several separately developed libraries that mysql is dependent upon.  If you are in an environment where you can grab all of the
  dependencies you can do that.  Otherwise you will need to locate and download all of the dependencies and place them inside the folder "node_modules".
  As of 9/2016 the "node_modules" folder structure is:
	/node_modules/mysql-master (the mysql library which could be renamed to mysql)
	/node_modules/bignumber.js
	/node_modules/buffer-shims
	/node_modules/core-util-is
	/node_modules/inherits
	/node_modules/isarray
	/node_modules/process-nextick-args
	/node_modules/readable-stream
	/node_modules/sqlstring
	/node_modules/util-deprecate
*/

/*
MYSQL
*/
var mysql = require("mysql-master"); /* You could just as well rename the folder to "mysql" and update this require to "mysql" if desired */
var mysqlstatement = "";
var mysqlconnect = {
	host: 'talktome-cluster.cluster-stickywaffles.us-east-1.rds.amazonaws.com',
	database: 'yourdatabase',
	user: 'kangaroo',
	password: 'willywanka',
	port: '3306'
};

/*
DEFAULT MAIN FUNCTION CALL
*/
exports.handler = function(event, context) {
	/* Create mySQL statement.  The forward slash at the end of each line is to instruct old versions of node that the string has a line break.  Because node. */
	mysqlstatement = "SELECT\
			somecolumn\
		FROM yourtable\
		LIMIT 0, 50\
	;";

	/* Filter out tabs and the space semi-colon */
	mysqlstatement = mysqlstatement.replace(/\t+/g, " ").replace(/\s\;/g, ";");

	/* Create the mySQL connection to use for this function */
	var connection = mysql.createConnection(mysqlconnect);

	/* Create the mySQL statement to use */
	connection.query(mysqlstatement, function(err, rows, fields) {
		if (err) {
			/* mySQL Error */
			context.done(
				null,
				{
				"Error": JSON.stringify(err, null, 2)
				}
			);
		}
		else {
			/* Statement completed, let's see what we've got */
			context.done(
				null,
				{
				"Result": rows
				}
			);
		}
	});

	/* Free the connection */
	connection.end();
};